> ## Documentation Index
> Fetch the complete documentation index at: https://docs.x.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Retweets Lookup

> This guide walks you through retrieving users who Retweeted a specific Post. Reference for the X API v2 standard tier covering quickstart.

export const Button = ({href, children}) => {
  return <div className="not-prose group">
    <a href={href}>
      <button className="flex items-center space-x-2.5 py-1 px-4 bg-primary-dark dark:bg-white text-white dark:text-gray-950 rounded-full group-hover:opacity-[0.9] font-medium">
        <span>
          {children}
        </span>
        <svg width="3" height="24" viewBox="0 -9 3 24" class="h-6 rotate-0 overflow-visible"><path d="M0 0L3 3L0 6" fill="none" stroke="currentColor" stroke-width="1.5" stroke-linecap="round"></path></svg>
      </button>
    </a>
  </div>;
};

This guide walks you through retrieving users who Retweeted a specific Post.

<Note>
  **Prerequisites**

  Before you begin, you'll need:

  * A [developer account](https://developer.x.com/en/portal/petition/essential/basic-info) with an approved App
  * Your App's Bearer Token (for public data) or User Access Token (for private metrics)
</Note>

***

## Get users who Retweeted a Post

<Steps>
  <Step title="Find the Post ID">
    Get the ID of the Post you want to look up Retweets for:

    ```
    https://x.com/XDevelopers/status/1354143047324299264
                                    └── This is the Post ID
    ```
  </Step>

  <Step title="Make the request">
    <CodeGroup dropdown>
      ```bash cURL theme={null}
      curl "https://api.x.com/2/tweets/1354143047324299264/retweeted_by?\
      user.fields=created_at,username,verified" \
        -H "Authorization: Bearer $BEARER_TOKEN"
      ```

      ```python Python SDK theme={null}
      from xdk import Client

      client = Client(bearer_token="YOUR_BEARER_TOKEN")

      # Get users who Retweeted a Post with pagination
      for page in client.posts.get_retweeted_by(
          "1354143047324299264",
          user_fields=["created_at", "username", "verified"]
      ):
          for user in page.data:
              print(f"{user.username} - Joined: {user.created_at}")
      ```

      ```javascript JavaScript SDK theme={null}
      import { Client } from "@xdevplatform/xdk";

      const client = new Client({ bearerToken: "YOUR_BEARER_TOKEN" });

      // Get users who Retweeted a Post with pagination
      const paginator = client.posts.getRetweetedBy("1354143047324299264", {
        userFields: ["created_at", "username", "verified"],
      });

      for await (const page of paginator) {
        page.data?.forEach((user) => {
          console.log(`${user.username} - Joined: ${user.created_at}`);
        });
      }
      ```
    </CodeGroup>
  </Step>

  <Step title="Review the response">
    ```json theme={null}
    {
      "data": [
        {
          "created_at": "2008-12-04T18:51:57.000Z",
          "id": "17874544",
          "username": "TwitterSupport",
          "name": "Twitter Support",
          "verified": true
        },
        {
          "created_at": "2007-02-20T14:35:54.000Z",
          "id": "783214",
          "username": "Twitter",
          "name": "Twitter",
          "verified": true
        }
      ],
      "meta": {
        "result_count": 2,
        "next_token": "7140dibdnow9c7btw3z2vwioavpvutgzrzm9icis4ndix"
      }
    }
    ```
  </Step>
</Steps>

***

## Include additional data

Use expansions to get related data like pinned Posts:

<CodeGroup dropdown>
  ```bash cURL theme={null}
  curl "https://api.x.com/2/tweets/1354143047324299264/retweeted_by?\
  user.fields=created_at&\
  expansions=pinned_tweet_id&\
  tweet.fields=created_at" \
    -H "Authorization: Bearer $BEARER_TOKEN"
  ```

  ```python Python SDK theme={null}
  from xdk import Client

  client = Client(bearer_token="YOUR_BEARER_TOKEN")

  # Get Retweeting users with expansions
  for page in client.posts.get_retweeted_by(
      "1354143047324299264",
      user_fields=["created_at"],
      expansions=["pinned_tweet_id"],
      tweet_fields=["created_at"]
  ):
      for user in page.data:
          print(f"{user.username}")
      # Pinned Posts are in page.includes.tweets
  ```

  ```javascript JavaScript SDK theme={null}
  import { Client } from "@xdevplatform/xdk";

  const client = new Client({ bearerToken: "YOUR_BEARER_TOKEN" });

  // Get Retweeting users with expansions
  const paginator = client.posts.getRetweetedBy("1354143047324299264", {
    userFields: ["created_at"],
    expansions: ["pinned_tweet_id"],
    tweetFields: ["created_at"],
  });

  for await (const page of paginator) {
    page.data?.forEach((user) => {
      console.log(user.username);
    });
    // Pinned Posts are in page.includes?.tweets
  }
  ```
</CodeGroup>

### Response with expansion

```json theme={null}
{
  "data": [
    {
      "pinned_tweet_id": "1389270063807598594",
      "created_at": "2018-11-21T14:24:58.000Z",
      "id": "1065249714214457345",
      "username": "TwitterSpaces",
      "name": "Spaces"
    }
  ],
  "includes": {
    "tweets": [
      {
        "created_at": "2021-05-03T17:26:09.000Z",
        "id": "1389270063807598594",
        "text": "now, everyone with 600 or more followers can host a Space..."
      }
    ]
  }
}
```

***

## Next steps

<CardGroup cols={2}>
  <Card title="Manage Retweets" icon="retweet" href="/x-api/posts/retweets/quickstart/manage-retweets">
    Retweet and undo Retweets
  </Card>

  <Card title="Quote Posts" icon="quote-left" href="/x-api/posts/quote-tweets/quickstart">
    Get Quote Posts
  </Card>

  <Card title="API Reference" icon="code" href="/x-api/posts/get-reposted-by">
    Full endpoint documentation
  </Card>
</CardGroup>
